<?php
    require('../business/User.php');
    class UserModel{
        private $con; 
        private $gat;
        
        public function __construct(Connection $con) {
            $this->con = $con;
            $this->gat = new UserGateway($con);
        }
        
        function connexion($login, $mdp){
            $result = $this->gat->findUser($login, $mdp);
            if (isset($result))
            {
                $_SESSION['login'] = $result;
            }
            echo $_SESSION['login'];
        }

        function deconnexion(){
            session_unset();
            session_destroy();
            $_SESSION = array();
        }

        function isConnected($login){ //teste rôle dans la session, retourne instance d’objet ou booleen 
            if ($_SESSION['login'])
            {
                return true;
            }
            else return false;
        }

        function ajouter($login, $mdp){
            $user = $this->findByLogin($login);
            if (empty($user))
                $this->gat->create($login, $mdp);
        }

        function supprimer($login){
            $this->gat->delete($login);
        }

        function modifMdp($login, $mdp){
            $this->gat->updateMdp($login, $mdp);
        }

        function findByLogin($login){
            $user = null;
            if ($login !== " " && $login != null )
            {
                $results = $this->gat->find($login, 'login');
                foreach($results as $row){
                    $user = new User($results['login']);
                }
                return $user;
            }
        }

        function modifLogin($oldLogin, $newLogin){
            $user = $this->findByLogin($oldLogin);
            if (empty($user))
                $this->gat->updateLogin($oldLogin, $newLogin);
        }
    }

?>